//+------------------------------------------------------------------+
//|                                        Time_Left_Timer_Based.mq5 |
//|                        Copyright 2019, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+

#property copyright "Copyright 2019, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_plots 1
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
string Obj_Name = "Timer_Left_for_candle_complete";
datetime x_position;
double y_position;
int division_by = 60;
int m,s;
bool is_Custom = false;
#import "winmm.dll"
   int timeBeginPeriod(uint per);
#import
void OnTimer()
  {
//EventKillTimer();
   if(is_Custom == true)
      x_position = TimeCurrent()+(PeriodSeconds()*60)+20;
   else
      x_position = TimeCurrent()+20;
   y_position = iClose(_Symbol,_Period,0)+0.00002;
   s--;
   if(s<0)
     {
      SetTime();
     }
   if(ObjectFind(ChartID(),Obj_Name)>=0)
     {
      TextMove(ChartID(),Obj_Name,x_position,y_position);
      TextChange(ChartID(),Obj_Name,StringFormat("%d : %02d",m,s));
     }
   else
     {
      TextCreate(Obj_Name,x_position,y_position,StringFormat("%d : %02d",m,s));
     }
   ChartRedraw(0);
//EventSetTimer(1);

   return;
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnInit()
  {
  timeBeginPeriod(1);
   if(SymbolInfoInteger(_Symbol,SYMBOL_CUSTOM)==1)
      is_Custom = true;
   SetTime();
   TextCreate(Obj_Name,x_position,y_position,StringFormat("%d : %02d",m,s));
   division_by = 60;
   EventSetTimer(1);
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
   return(0);
  }

//+------------------------------------------------------------------+
void OnDeinit(const int r)
  {
   ObjectDelete(ChartID(),Obj_Name);
   EventKillTimer();
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SetTime()
  {
   x_position = TimeCurrent()+(PeriodSeconds()*60);
   y_position = iClose(_Symbol,_Period,0)+0.00002;
   m=int(iTime(_Symbol,_Period,0)+PeriodSeconds()-TimeCurrent());
   s=m%division_by;
   if(is_Custom == true)
      m=((m-s)/division_by)-PeriodSeconds();
   else
      m=((m-s)/division_by);
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool TextCreate(const string            name="Text",              // object name
                datetime                time=0,                   // anchor point time
                double                  price=0,                  // anchor point price
                const string            text="Text"             // the text itself
               )                // priority for mouse click
  {
//--- set anchor point coordinates if they are not set
   ChangeTextEmptyPoint(time,price);
   string font="Arial Black";
   color clr=clrAqua;
   int font_size=10;
   int sub_window=0;
   long chart_ID=ChartID();
   double            angle=0.0;                // text slope
   ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT_UPPER; // anchor type
   bool              back=false;               // in the background
   bool              selection=false;          // highlight to move
   bool              hidden=true;              // hidden in the object list
   long              z_order=0;
//--- reset the error value
   ResetLastError();
//--- create Text object
   if(!ObjectCreate(chart_ID,name,OBJ_TEXT,sub_window,time,price))
     {
      Print(__FUNCTION__,
            ": failed to create \"Text\" object! Error code = ",GetLastError());
      return(false);
     }
//--- set the text
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
//--- set text font
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
//--- set font size
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
//--- set the slope angle of the text
   ObjectSetDouble(chart_ID,name,OBJPROP_ANGLE,angle);
//--- set anchor type
   ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,anchor);
//--- set color
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//--- display in the foreground (false) or background (true)
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//--- enable (true) or disable (false) the mode of moving the object by mouse
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//--- hide (true) or display (false) graphical object name in the object list
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//--- set the priority for receiving the event of a mouse click in the chart
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//--- successful execution
   return(true);
  }
//+------------------------------------------------------------------+
//| Move the anchor point                                            |
//+------------------------------------------------------------------+
bool TextMove(const long   chart_ID=0,  // chart's ID
              const string name="Text", // object name
              datetime     time=0,      // anchor point time coordinate
              double       price=0)     // anchor point price coordinate
  {
//--- if point position is not set, move it to the current bar having Bid price
   if(!time)
      time=TimeCurrent();
   if(!price)
      price=SymbolInfoDouble(Symbol(),SYMBOL_BID);
//--- reset the error value
   ResetLastError();
//--- move the anchor point
   if(!ObjectMove(chart_ID,name,0,time,price))
     {
      Print(__FUNCTION__,
            ": failed to move the anchor point! Error code = ",GetLastError());
      return(false);
     }
//--- successful execution
   return(true);
  }
//+------------------------------------------------------------------+
//| Change the object text                                           |
//+------------------------------------------------------------------+
bool TextChange(const long   chart_ID=0,  // chart's ID
                const string name="Text", // object name
                const string text="Text") // text
  {
//--- reset the error value
   ResetLastError();
//--- change object text
   if(!ObjectSetString(chart_ID,name,OBJPROP_TEXT,text))
     {
      Print(__FUNCTION__,
            ": failed to change the text! Error code = ",GetLastError());
      return(false);
     }
//--- successful execution
   return(true);
  }
//+------------------------------------------------------------------+
//| Delete Text object                                               |
//+------------------------------------------------------------------+
bool TextDelete(const long   chart_ID=0,  // chart's ID
                const string name="Text") // object name
  {
//--- reset the error value
   ResetLastError();
//--- delete the object
   if(!ObjectDelete(chart_ID,name))
     {
      Print(__FUNCTION__,
            ": failed to delete \"Text\" object! Error code = ",GetLastError());
      return(false);
     }
//--- successful execution
   return(true);
  }
//+------------------------------------------------------------------+
//| Check anchor point values and set default values                 |
//| for empty ones                                                   |
//+------------------------------------------------------------------+
void ChangeTextEmptyPoint(datetime &time,double &price)
  {
//--- if the point's time is not set, it will be on the current bar
   if(!time)
      time=TimeCurrent();
//--- if the point's price is not set, it will have Bid value
   if(!price)
      price=SymbolInfoDouble(Symbol(),SYMBOL_BID);
  }
//+------------------------------------------------------------------+
